package org.bndtools.runtime.controller.internal;

import java.lang.reflect.Method;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTracker;

public class LogTracker extends ServiceTracker implements Log {
	
	private final Log console = new ConsoleLog();

    public LogTracker(final BundleContext context) {
        super(context, "org.osgi.service.log.LogService", null);
    }

    public void log(ServiceReference sr, final int level, final String message, final Throwable exception) {
    	Object log = getService();
    	if (log == null) {
    		console.log(sr, level, message, exception);
    	} else {
    		try {
				Method logMethod = log.getClass().getMethod("log", new Class[] { ServiceReference.class, Integer.TYPE, String.class, Throwable.class });
				logMethod.invoke(log, new Object[] { null, new Integer(level), message, exception });
			} catch (Exception e) {
				System.err.println("ERROR reflectively invoking LogService");
				console.log(sr, level, message, exception);
			}
    	}
    }


}
